struct controller_s {
	uint8_t A;
	uint8_t B;
	uint8_t select;
	uint8_t start;
	uint8_t up;
	uint8_t down;
	uint8_t left;
	uint8_t right;
};

union controller_u {
	struct controller_s buttonname;
	uint8_t buttonvalue[8];
};

struct inputdev_s {
	uint8_t currentread;
	union controller_u gamepad;
	uint32_t mapping[8];
	uint8_t hatmap[8];
	uint8_t joynum[8];
	uint8_t inputmethod;
};

struct joystick_s {
	uint8_t numbuttons;
	uint8_t numhats;
	SDL_Joystick *sdljoy;
};

#define INPUT_METHOD_KEYBOARD 0
#define INPUT_METHOD_JOYSTICK 1
#define INPUT_EVENT_PRESS     0
#define INPUT_EVENT_UNPRESS   1
#define JOY_BUTTON_UP          0
#define JOY_BUTTON_DOWN        1
#define JOY_BUTTON_LEFT        2
#define JOY_BUTTON_RIGHT       3
#define JOY_BUTTON_LEFTUP      4
#define JOY_BUTTON_LEFTDOWN    5
#define JOY_BUTTON_RIGHTUP     6
#define JOY_BUTTON_RIGHTDOWN   7
